//=============================================================================
// Gift Box Weapon bases. Static Mesh models and skins by Aberiu, swapping code Meowcat
//=============================================================================
class mute_WeaponGiftBoxes extends Mutator;

#exec OBJ LOAD FILE=UChristmasPickups_tex.utx
#exec OBJ LOAD FILE=UChristmasPickups_mesh.usx

function BeginPlay(){
    local xPickupBase P;
    local GiftBoxBase GBB;

    //log("mute_WeaponGiftBoxes: BeginPlay()!" );// DEBUG LOG
    // This will probably only run on the server/listen-server
    ForEach AllActors(class'xPickupBase', P, ){
         P.bHidden=true; // only resort to this if we need to spawn a "dummy" static mesh actor
         P.SetDrawType(DT_none); // <- this seems to work...
         if(xWeaponBase(P) != None && xWeaponBase(P).WeaponType != None){
              GBB = Spawn(class'GiftBoxBase',P,,P.Location,P.Rotation);
              P.SpawnHeight = ReplaceWeaponBase(GBB, xWeaponBase(P).WeaponType);
         }else if(P.PowerUp !=none){
              GBB = Spawn(class'GiftBoxBase',P,,P.Location,P.Rotation);
              P.SpawnHeight = ReplacePowerUpBase(GBB, P.PowerUp);
         }
    }
    Super.BeginPlay();
}

simulated function PostNetBeginPlay(){
    local xPickupBase P;
    //local int i;
    local GiftBoxBase GBB;

    super.PostNetBeginPlay();
    //log("mute_WeaponGiftBoxes: PostNetBeginPlay()!" );// DEBUG LOG
    if(Level.NetMode != NM_Client) return; // drop out now if we're not a client

    // change all of the pickup bases, maybe this will work on the clients here...
    //i = 0;
    ForEach AllActors(class'xPickupBase', P, ){
         P.bHidden=true; // only resort to this if we need to spawn a "dummy" static mesh actor
         P.SetDrawType(DT_none); // <- this seems to work...
         if(xWeaponBase(P) != None && xWeaponBase(P).WeaponType != None){
              GBB = Spawn(class'GiftBoxBase',P,,P.Location,P.Rotation);
              P.SpawnHeight = ReplaceWeaponBase(GBB, xWeaponBase(P).WeaponType);
         }else if(P.PowerUp !=none){
              GBB = Spawn(class'GiftBoxBase',P,,P.Location,P.Rotation);
              P.SpawnHeight = ReplacePowerUpBase(GBB, P.PowerUp);
         }
         //i++;
    }
    //log("mute_WeaponGiftBoxes: Client PNBP - Changed "@i @"xPickup bases" );// DEBUG LOG
}

simulated function float ReplaceWeaponBase(actor P, class<weapon> OldWeapon){
    // Trying to directly SetStaticMesh on the pickup bases did not work on clients (but it did work on the server/standalone?)
    // aternatively, maybe just set a local string variable in each case,
    // then load the the staticmesh dynamically at the end...

    if ( OldWeapon == class'AssaultRifle'){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCPC_bio');
        //P.SetDrawScale(2.0);
    }else if ( OldWeapon == class'ShockRifle' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_shock');
	}else if ( OldWeapon == class'BioRifle' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_bio');
	}else if ( OldWeapon == class'Linkgun' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_link');
	}else if ( OldWeapon == class'Minigun' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_mini');
	}else if ( OldWeapon == class'FlakCannon' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_flak');
	}else if ( OldWeapon == class'RocketLauncher' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_rocket');
	}else if ( OldWeapon == class'SniperRifle' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_LG');
    }else if ( OldWeapon == class'ClassicSniperRifle' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_sniper');
    }else if ( OldWeapon == class'Redeemer' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_heavy');
	}else if ( OldWeapon == class'ONSAVRIL' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_heavy');
	}else if ( OldWeapon == class'ONSGrenadeLauncher' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_heavy');
	}else if ( OldWeapon == class'ONSMineLayer' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_heavy');
	}else if ( OldWeapon == class'ONSPainter' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_heavy');
	}else if ( OldWeapon == class'Painter' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_heavy');
	}else if ( OldWeapon == class'ShieldGun' ){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCPC_bio');
	}else{
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCPC_flak');
    }
    return 50.0;
}

simulated function float ReplacePowerUpBase(actor P, class<PickUp> PowerUp){
    //if ( PowerUp.IsA('TournamentHealth')){
    if ( class<TournamentHealth>(PowerUp) != none){
        if ( class<SuperHealthPack>(PowerUp) != none){
            P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_PWR_big');
            P.Skins[0]=material'UChristmasPickups_tex.UCP_HP_blend';
            return 80.0;
        }else{
           P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_PWR_sm');
           return 60.0;
        }
    //}else if ( PowerUp.IsA('UDamagePack') ){
    }else if ( class<UDamagePack>(PowerUp) != none){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_PWR_big');
        return 80.0;
	//}else if ( PowerUp.IsA('ShieldPickup')){
	}else if ( class<ShieldPickup>(PowerUp) != none){
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_PWR_big');
        P.Skins[0]=material'UChristmasPickups_tex.UCP_armor_blend';
        if ( class<ShieldPack>(PowerUp) != none) return 68.0;
        else return 80.0;
	}else{
        P.SetStaticMesh(staticmesh'UChristmasPickups_mesh.UCP_PWR_big');
        P.Skins[0]=material'UChristmasPickups_tex.UCP_wildcard_blend';
        return 80.0;
    }
    return 50.0;
}

defaultproperties
{
    IconMaterialName="MutatorArt.nosym"
    ConfigMenuClassName=""
    GroupName="weapongiftboxes"
    FriendlyName="UT Christmas Weapon Gift Boxes"
    Description="UT Christmas Weapon Gift Boxes - Mutator replaces all weapon and powerup pickup bases with Christmas gift boxes. || Models and textures by Aberiu |mutator code by meowcat"

    RemoteRole=ROLE_SimulatedProxy
    bAlwaysRelevant=True
    bAddToServerPackages=true
}
